/*
 * Copyright 1998-2007 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2007 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/******************************Module*Header*******************************
* Module Name: VidInit.h
*
* Put all video function and parameters.
*
**************************************************************************/

#ifndef _VIDINIT_H
#define _VIDINIT_H

#ifdef XFree86Server
#include "via_video.h"  /* for viaPortPrivPtr struct */
#include "xf86fbman.h"  /* for FBLinearPtr */
#endif /* XFree86Server */
#include "VidStruc.h"   /* VIDDATA, video top level structure */
#include "close/via_memmgr.h" /* ViaMMReq structure */

/**************************************************************************
* Global Variable for Video function
**************************************************************************/


/**************************************************************************
* Extern Variable for Video function
**************************************************************************/
/* extern PVIDDATA pVidData; */


/**************************************************************************
* Extern function for Video function
**************************************************************************/


/**************************************************************************
* Defination for Video function
**************************************************************************/

/**************************************************************************
* Structure defination for Video function
**************************************************************************/

/*Wait Function Structure and Flag*/
typedef struct _WaitHWINFO
{
    unsigned char* pjVideo;				/*MMIO Address Info*/
    unsigned long dwVideoFlag;				/*Video Flag*/
}WaitHWINFO, * LPWaitHWINFO;


/**************************************************************************
* function defination for Video Driver
**************************************************************************/

unsigned long DispatchVGARevisionID(PVIDDATA pVidData);
Bool vfMapVideoFun(PVIDDATA pVidData);
void vfInitVideoInfo(PVIDDATA pVidData);
void vfInitHWDiff(PVIDDATA pVidData);
void MPEGFlipCurrentFrame(PVIDDATA pVidData);

/* VQ Control */
void vfEnable2DVQ(PVIDDATA pVidData);
void vfDisable2DVQ(PVIDDATA pVidData);

/* VQ Control for VT3259 */
void vfInitVideoVQ(PVIDDATA pVidData);
void vfEnableVQ_CME(PVIDDATA pVidData);
void vfDisableVQ_CME(PVIDDATA pVidData);

void vfEnableAGP_CME(PVIDDATA pVidData);
void vfDisableAGP_CME(PVIDDATA pVidData);

/*
 *  Function pointer for chips specific function assignment
 */
/* Video Function pointer declaration */
#ifdef LINUX_2_6
extern unsigned long (*fpFlip)(PVIDDATA pVidData, unsigned long DisplayBufferIndex);
#else
unsigned long (*fpFlip)(PVIDDATA pVidData, unsigned long DisplayBufferIndex);
#endif

#ifdef XFree86Server
unsigned long (*fpUpd_Video)(PVIDDATA pVidData);                 
unsigned long (*fpUpd_MPEG)(PVIDDATA pVidData);
unsigned long (*fpUpd_Capture0)(PVIDDATA pVidData, RegionPtr clipBoxes, viaPortPrivPtr pPriv);
unsigned long (*fpUpd_Capture1)(PVIDDATA pVidData, RegionPtr clipBoxes, viaPortPrivPtr pPriv);
unsigned long (*fpCreateSurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long (*fpDestroySurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
#elif LINUX_2_6
extern unsigned long (*fpUpd_Video)(PVIDDATA pVidData);                 
extern unsigned long (*fpUpd_MPEG)(PVIDDATA pVidData);
extern unsigned long (*fpUpd_Capture0)(PVIDDATA pVidData);
extern unsigned long (*fpUpd_Capture1)(PVIDDATA pVidData);
extern unsigned long (*fpCreateSurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
extern unsigned long (*fpDestroySurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
#elif defined(__KERNEL__)
unsigned long (*fpUpd_Video)(PVIDDATA pVidData);                 
unsigned long (*fpUpd_MPEG)(PVIDDATA pVidData);
unsigned long (*fpUpd_Capture0)(PVIDDATA pVidData);
unsigned long (*fpUpd_Capture1)(PVIDDATA pVidData);
unsigned long (*fpCreateSurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long (*fpDestroySurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
#endif /* XFree86Server */

#ifdef HW_SLICE
unsigned long (*fpUpd_Video)(PVIDDATA pVidData);      
unsigned long (*fpUpd_MPEG)(PVIDDATA pVidData);
unsigned long (*fpCreateSurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long (*fpDestroySurface)(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long (*fpFlip)(PVIDDATA pVidData, unsigned long DisplayBufferIndex);
#endif


#ifdef XFree86Server
/* CLE Video function declaration */
unsigned long Upd_Video(PVIDDATA pVidData);
unsigned long Upd_MPEG(PVIDDATA pVidData);
unsigned long Upd_Capture0(PVIDDATA pVidData, RegionPtr clipBoxes, viaPortPrivPtr pPriv);
unsigned long Upd_Capture1(PVIDDATA pVidData, RegionPtr clipBoxes, viaPortPrivPtr pPriv);
unsigned long CreateSurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CLE(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

/* CME Video function declaration */
unsigned long Upd_Video_CME(PVIDDATA pVidData);
unsigned long Upd_MPEG_CME(PVIDDATA pVidData);
unsigned long Upd_Capture0_CME(PVIDDATA pVidData, RegionPtr clipBoxes, viaPortPrivPtr pPriv);
unsigned long Upd_Capture1_CME(PVIDDATA pVidData, RegionPtr clipBoxes, viaPortPrivPtr pPriv);
unsigned long CreateSurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CME(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

FBLinearPtr  XAllocFB(PVIDDATA pVidData, FBLinearPtr lpFBlinear, unsigned long dwFBsize);

#elif defined(__KERNEL__) 
/* CLE Video function declaration */
unsigned long Upd_Video(PVIDDATA pVidData);
unsigned long Upd_MPEG(PVIDDATA pVidData);
unsigned long Upd_Capture0(PVIDDATA pVidData);
unsigned long Upd_Capture1(PVIDDATA pVidData);
unsigned long CreateSurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CLE(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

/* CME Video function declaration */
unsigned long Upd_Video_CME(PVIDDATA pVidData);
unsigned long Upd_MPEG_CME(PVIDDATA pVidData);
unsigned long Upd_Capture0_CME(PVIDDATA pVidData);
unsigned long Upd_Capture1_CME(PVIDDATA pVidData);
unsigned long CreateSurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CME(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

unsigned long VIAAllocFB(PVIDDATA pVidData, ViaMMReq * lpMemRequest, unsigned long dwFBsize);
#endif /* XFree86Server */

#if defined(HW_SLICE)
unsigned long Upd_Video(PVIDDATA pVidData);
unsigned long Upd_MPEG(PVIDDATA pVidData);
unsigned long CreateSurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long Flip_CLE(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

unsigned long Upd_Video_CME(PVIDDATA pVidData);
unsigned long Upd_MPEG_CME(PVIDDATA pVidData);
unsigned long CreateSurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long DestroySurface_CME(PVIDDATA pVidData, LPDDSURFACEDESC lpDDSurfaceDesc);
unsigned long VIAAllocFB(PVIDDATA pVidData, ViaMMReq * lpMemRequest, unsigned long dwFBsize);
unsigned long Flip_CME(PVIDDATA pVidData, unsigned long DisplayBufferIndex);

#endif

#ifdef HW_SLICE
/* MPEG Function pointer declaration */
unsigned long  (*fpVIA_MPEGConnect)(void* lpVidData); 
unsigned long  (*fpVIA_MPEGDisConnect)(void* lpVidData);
unsigned long  (*fpVIA_MPEGBeginPicture)(void*  lpVidData);
unsigned long  (*fpVIA_MPEGEndPicture)(void*  lpVidData);
unsigned long  (*fpVIA_MPEGSliceReceiveData)(PVIDDATA pVidData,unsigned long dwBitStreamCount, unsigned char * lpVid);
unsigned long  (*fpVIA_MPEGSliceReceiveDataEx)(unsigned long dwSliceCount, unsigned char * lpVid, unsigned long dwEncryptionKey);
unsigned long  (*fpVIA_MPEGSingleSliceReceiveData)(unsigned long dwBitStreamCount, unsigned char * lpVid, unsigned long sCode);
unsigned long  (*fpVIA_MPEGSetMacroBlock)(void*  lpVidData, LPVIAMACROBLOCK lpMacroBlock);
unsigned long  (*fpVIA_MPEGSetFrameBuffer)(void* lpVidData);
unsigned long  (*fpVIA_MPEGDisplayControl)( void * lpVidData);
unsigned long  (*fpVIA_MPEGSetQMatrix)( void * lpVidData);
unsigned long  (*fpVIADisplayControl)( LPVMI_FLIP_PARAM lpFlip);
unsigned long  (*fpVIASUBPicture)(void * lpSubp);

/* CLE MPEG function declaration */
unsigned long  VIA_MPEGConnect_CLE(void* lpVidData); 
unsigned long  VIA_MPEGDisConnect_CLE(void* lpVidData);
unsigned long  VIA_MPEGBeginPicture_CLE(void*  lpVidData);
unsigned long  VIA_MPEGEndPicture_CLE(void*  lpVidData);
unsigned long  VIA_MPEGSliceReceiveData_CLE(PVIDDATA pVidData,unsigned long dwBitStreamCount, unsigned char * lpVid);
unsigned long  VIA_MPEGSliceReceiveDataEx_CLE(unsigned long dwSliceCount, unsigned char * lpVid, unsigned long dwEncryptionKey);
unsigned long  VIA_MPEGSingleSliceReceiveData_CLE(unsigned long dwBitStreamCount, unsigned char * lpVid, unsigned long sCode);
/* unsigned long  VIA_MPEGSetMacroBlock_CLE(void*  lpVidData, LPVIAMACROBLOCK lpMacroBlock); */
unsigned long  VIA_MPEGSetFrameBuffer_CLE(void* lpVidData);
unsigned long  VIA_MPEGDisplayControl_CLE( void * lpVidData);
unsigned long  VIADisplayControl_CLE( LPVMI_FLIP_PARAM lpFlip );
unsigned long  VIASUBPicture_CLE(void * lpSubp);

/* KM MPEG function declaration */

/* CME MPEG function declaration */
//Vincent Lai [2003.07.14],for VT3259
// CME MPEG function declaration
unsigned long MPEG2Connect_CME(void * lpVidData);
unsigned long MPEG2DisConnect_CME(void * lpVidData);
unsigned long MPEG2SetLineOffset_CME(void * lpVidData);
unsigned long MPEG2SetFrameBuffer_CME(void * lpVidData);
unsigned long MPEG2SetQMatrix_CME(void * lpVidData);
unsigned long MPEG2BeginPicture_CME(void * lpVidData);
unsigned long MPEG2EndPicture_CME(void * lpVidData);
unsigned long MPEG2SetMacroBlock_CME(void * lpVidData, LPVIAMACROBLOCK lpMacroBlock);
unsigned long MPEG2SliceReceiveData_CME(PVIDDATA pVidData,unsigned long dwSliceCount, unsigned char * lpVid);
unsigned long MPEG2SingleSliceReceiveData_CME(unsigned long dwBitStreamCount, unsigned char * lpVid, unsigned long sCode);
unsigned long MPEG2DisplayControl_CME(void * lpVidData);
unsigned long VIADisplayControl_CME(LPVMI_FLIP_PARAM lpFlip);
unsigned long VIASUBPicture_CME(void * lpSubp);


unsigned long MPEG2Connect_MSD(void * lpVidData);
unsigned long MPEG2DisConnect_MSD(void * lpVidData);
unsigned long MPEG2SetLineOffset_MSD(void * lpVidData);
unsigned long MPEG2SetFrameBuffer_MSD(void * lpVidData, unsigned long dwAction);

unsigned long MPEG2SetQMatrix_MSD(void * lpVidData);
unsigned long MPEG2BeginPicture_MSD(void * lpVidData);
unsigned long MPEG2EndPicture_MSD(void * lpVidData);
unsigned long MPEG2SetMacroBlock_MSD(void * lpVidData,LPVIAMACROBLOCK lpMacroBlock);
unsigned long MPEG24SetMacroBlock_MSD(PVIDDATA pVidData, LPVIAMACROBLOCK lpMacroBlock);
unsigned long MPEG2SliceReceiveData_MSD(PVIDDATA pVidData,unsigned long dwSliceCount, unsigned char * lpVid);
unsigned long MPEG2SingleSliceReceiveData_MSD(unsigned long dwBitStreamCount, unsigned char * lpVid, unsigned long sCode);
unsigned long MPEG2DisplayControl_MSD(void * lpVidData);
void MPEG2ResetEngine_MSD(void * lpVidData);
/* BitBlt function declaration */
void VIABitBlt(unsigned bpp, unsigned srcBase, unsigned srcPitch,
               unsigned dstBase, unsigned dstPitch, unsigned w,
               unsigned h, int xdir, int ydir, unsigned blitMode, 
	           unsigned color);

void WaitIdle(void);

#endif /* HW_SLICE */


#endif    /* _VIDINIT_H */

