/*
 * Copyright 1998-2007 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2007 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
/* ------- mergedfb support add by cliff------ */
		/* Psuedo Xinerama support */
#define NEED_REPLIES  		/* ? */
#define EXTENSION_PROC_ARGS void *
#include "extnsionst.h"  	/* required */
#include "X11/extensions/panoramiXproto.h"  	/* required */
#define VIA_XINERAMA_MAJOR_VERSION  1
#define VIA_XINERAMA_MINOR_VERSION  1
#ifndef _VIA_BIOS_H_
#define _VIA_BIOS_H_ 1

#define IGA1	    1
#define IGA2	    2
#define IGA1_IGA2   3

#define SCREEN_INDEX_0  0
#define SCREEN_INDEX_1  1

#define VIA_BIOS_REG_TABLE_MAX_NUM	32
#define VIA_BIOS_REG_LCD_MAX_NUM	48
#define VIA_BIOS_NUM_RES		17
#define VIA_BIOS_NUM_REFRESH		5
#define VIA_BIOS_NUM_LCD_SUPPORT_MASK	8
#define VIA_BIOS_NUM_LCD_POWER_SEQ	4
#define VIA_BIOS_NUM_PANEL		11
#define VIA_BIOS_MAX_NUM_MPATCH2	18
#define VIA_BIOS_MAX_NUM_MPATCH1	9
#define VIA_BIOS_MAX_NUM_CTREXP		5
/* 00 - 8F, tv2,tv3,ch7019 are the same */
#define VIA_BIOS_MAX_NUM_TV_REG		144
#define VIA_BIOS_MAX_NUM_TV_CRTC	32
#define VIA_BIOS_NUM_TV_SPECIAL_REG	8
#define VIA_BIOS_MAX_NUM_TV_PATCH	8
#define VIA_BIOS_NUM_TV_OTHER		16
#define VIA_BIOS_NUM_TV2		2



/* The position of some BIOS information from start of BIOS */
#define     VIA_BIOS_SIZE_POS               0x2
#define     VIA_BIOS_OFFSET_POS             0x1B

/* The offset of table from table start */
#define     VIA_BIOS_CSTAB_POS              6
#define     VIA_BIOS_STDVGAREGTAB_POS       8
#define     VIA_BIOS_COMMEXTREGTAB_POS      10
#define     VIA_BIOS_STDMODEXTREGTAB_POS    12
#define     VIA_BIOS_EXTMODEREGTAB_POS      14
#define     VIA_BIOS_REFRESHMODETAB_POS     16
#define     VIA_BIOS_BIOSVER_POS            18
#define     VIA_BIOS_BCPPOST_POS            20
#define     VIA_BIOS_LCDMODETAB_POS         40
#define     VIA_BIOS_TVMODETAB_POS          42
#define     VIA_BIOS_TVMASKTAB_POS          44
#define     VIA_BIOS_MODEOVERTAB_POS        46
#define     VIA_BIOS_MODEFITTAB_POS         48
#define     VIA_BIOS_LCDPOWERON_POS         50
#define     VIA_BIOS_LCDPOWEROFF_POS        52
#define     VIA_BIOS_LCDMODEFIX_POS         54
#define     ZCR                             0x0
#define     ZSR                             0x1
#define     ZGR                             0x2

/* Video Mode Index (FB device driver's res. index)*/
#define M640x480        0x000
#define M720x480        0x001
#define M720x576        0x002
#define M800x480        0x003
#define M800x600        0x004
#define M848x480        0x005
#define M852x480        0x006
#define M960x600        0x007
#define M1000x600       0x008
#define M1088x612       0x009
#define M1024x512       0x00A
#define M1024x576       0x00B
#define M1024x600       0x00C
#define M1024x768       0x00D
#define M1152x720       0x00E
#define M1152x864       0x00F
#define M1200x720       0x010
#define M1280x600       0x011
#define M1280x720       0x012
#define M1280x768       0x013
#define M1280x800       0x014
#define M1280x960       0x015
#define M1280x1024      0x016
#define M1360x768       0x017
#define M1366x768       0x018
#define M1368x768       0x019
#define M1400x1050      0x01A
#define M1440x900       0x01B
#define M1440x1050      0x01C
#define M1600x900       0x01D
#define M1600x1024      0x01E
#define M1600x1200      0x01F
#define M1680x600       0x020
#define M1680x1050      0x021
#define M1792x1344      0x022
#define M1856x1392      0x023
#define M1920x1080      0x024
#define M1920x1080_DVI  0x124
#define M1920x1200      0x025
#define M1920x1200_DVI  0x125
#define M1920x1440      0x026
#define M2048x1536      0x027
#define M_INVALID       0xFFF


#define     VIA_REF_60HZ                    0x0001
#define     VIA_REF_56HZ                    0x0002
#define     VIA_REF_65HZ                    0x0004
#define     VIA_REF_70HZ                    0x0008
#define     VIA_REF_72HZ                    0x0010
#define     VIA_REF_75HZ                    0x0020
#define     VIA_REF_80HZ                    0x0040
#define     VIA_REF_85HZ                    0x0080
#define     VIA_REF_90HZ                    0x0100
#define     VIA_REF_100HZ                   0x0200
#define     VIA_REF_120HZ                   0x0400
#define     VIA_REF_86HZ                    0x0800       /* Interlaced */
#define     VIA_REF_94HZ                    0x1000       /* Interlaced */

#define     VIA_TVRES_640X480               0
#define     VIA_TVRES_800X600               1
#define     VIA_TVRES_1024X768              2
#define     VIA_TVRES_848X480               3
#define     VIA_TVRES_720X480               4
#define     VIA_TVRES_720X576               5
#define     VIA_TVRES_720X480_SDTV          6
#define     VIA_TVRES_1280X720              6
#define     VIA_TVRES_1920X1080             7
#define     VIA_TVRES_INVALID               0xFF


#define     VIA_NUM_REFRESH_RATE            5
#define     VIA_PANEL6X4                    0
#define     VIA_PANEL8X6                    1
#define     VIA_PANEL10X7                   2
#define     VIA_PANEL12X7                   3
#define     VIA_PANEL12X10                  4
#define     VIA_PANEL14X10                  5
#define     VIA_PANEL16X12                  6
#define     VIA_PANEL12X8                   7
#define     VIA_PANEL8X4                    8
#define     VIA_PANEL1366X7                 9
#define     VIA_PANEL1360X7                 10
#define     VIA_PANEL1920x1080              11
#define     VIA_PANEL1920x1200              12
#define     VIA_PANEL10X6                   13
#define     VIA_PANEL14X9                   14
#define     VIA_PANEL1280X720               15
#define     VIA_PANEL_INVALID               255

#define     VIA_NONETRANSMITTER             0x00
#define     VIA_VT3191                      0x01
#define     VIA_TTLTYPE                     0x07
#define     VIA_VT3192                      0x09
#define     VIA_VT3193                      0x0A
#define     VIA_SIL164                      0x0B
#define     VIA_SIL168                      0x0C
#define     VIA_SIL9030                     0x0D  /*HDMI*/
#define     VIA_VT1636                      0x0E    /* VT1636 LVDS. */
#define     VIA_Hardwired                   0x0F
#define     VIA_INTEGRATED_LVDS             0x41
#define     VIA_INTEGRATED_TMDS             0x42

#define     TVTYPE_NONE                     0x00
#define     TVTYPE_NTSC                     0x01
#define     TVTYPE_PAL                      0x02
#define     TVTYPE_480P                     0X03
#define     TVTYPE_576P                     0X04
#define     TVTYPE_720P                     0X05
#define     TVTYPE_1080I                    0X06

/******************************************************************************
 * Definition TV Ouput Signal						      *
 ******************************************************************************/
#define TV_OUTPUT_NONE				0
#define TV_OUTPUT_COMPOSITE			1
#define TV_OUTPUT_SVIDEO			2
#define TV_OUTPUT_COMPOSITE_SVIDEO		3
#define TV_OUTPUT_RGB				4
#define TV_OUTPUT_YPBPR				5
#define TV_OUTPUT_RGB_COMPOSITE			6
#define TV_OUTPUT_YPBPR_COMPOSITE		7
#define TV_OUTPUT_SDTV_PROGRESSIVE_RGB		8
#define TV_OUTPUT_SDTV_PROGRESSIVE_YPBPR	9
#define TV_OUTPUT_HDTV_720P_RGB			10
#define TV_OUTPUT_HDTV_720P_YPBPR		11
#define TV_OUTPUT_HDTV_1080I_RGB		12
#define TV_OUTPUT_HDTV_1080I_YPBPR		13
#define TV_OUTPUT_HDTV_1080P_RGB		14
#define TV_OUTPUT_HDTV_1080P_YPBPR		15
#define TV_OUTPUT_DEDOTCRAWL			16
#define TV_OUTPUT_YPBPR_COMPOSITE_SVIDEO	17
#define TV_OUTPUT_RGB_COMPOSITE_SVIDEO		18

#define     VIA_NONETV                      0
#define     VIA_VT1621                      1       /* TV2 PLUS*/
#define     VIA_VT1622                      2       /* TV3 */
#define     VIA_VT1622A                     7       /* TV3 Advance */
#define     VIA_VT1623                      9       /* TV3 Advance for AGP slot*/ 
#define     VIA_VT1625                      11      /* VT1625 */
#define     VIA_INTEGRATED_TV               12      /* Integrated TV */

#define     VIA_TVNORMAL                    0
#define     VIA_TVFIT                       1
#define     VIA_TVOVER                      2

#define     VIA_NO_TVSCALE                  0
#define     VIA_TVSCALE1                    1
#define     VIA_TVSCALE2                    2
#define     VIA_TVSCALE3                    3
#define     VIA_TVSCALE4                    4
#define     VIA_TVSCALE5                    5

#define     VIA_TV_NUM_HSCALE_LEVEL         8
#define     VIA_TV_NUM_HSCALE_REG           16

#define     VIA_DEVICE_CRT1                 0x01
#define     VIA_DEVICE_LCD                  0x02
#define     VIA_DEVICE_TV                   0x04
#define     VIA_DEVICE_DFP                  0x08
#define     VIA_DEVICE_CRT2                 0x10
#define     VIA_DEVICE_LCD2                 0x20
#define     VIA_DEVICE_TV2                  0x40
#define     VIA_DEVICE_DFP2                 0x80


/* System Memory CLK */
#define		VIA_MEM_SDR66					0x00
#define		VIA_MEM_SDR100					0x01
#define		VIA_MEM_SDR133					0x02
#define		VIA_MEM_DDR200					0x03
#define		VIA_MEM_DDR266					0x04
#define		VIA_MEM_DDR333					0x05
#define		VIA_MEM_DDR400					0x06

/* Digital Output Bus Width */
#define		VIA_DI_12BIT					0x00
#define		VIA_DI_24BIT					0x01

#define     VIAGETBIOSDATE                  0x01
#define     VIAGETBIOSVER                   0x02

/* For 205 or later, there are many case for digital out put.
 * for example: TV can use DVP0(AMR slot), DFP High-half, DFP Low-half
 *              or DVP1 (mobile version).
 * We must distinguish which digital port has been using by device.
 */
/* Digital Output Bus Port */
#define     VIA_DI_NONE                     0x000
#define     VIA_DI_DVP0                     0x001
#define     VIA_DI_DVP1                     0x002
#define     VIA_DI_DFPHIGH                  0x004
#define     VIA_DI_DFPLOW                   0x008
#define     VIA_DI_DFPHIGHLOW               0x010
#define     VIA_DI_LVDS0                    0x020
#define     VIA_DI_LVDS1                    0x040
#define     VIA_DI_LVDS0LVDS1               0x080
#define     VIA_DI_TMDS                     0x100

/* RainLin [2005.12.22]: For HW strapping issue. */
#define     SLOT_AMR       1
#define     SLOT_AGP       2

#define     NOT_FOUND_DEV               0
#define     FOUND_INTERNAL_DEV          1
#define     FOUND_EXTERNAL_DEV_BY_I2C   2
#define     FOUND_EXTERNAL_DEV_BY_GPIO  3

/* Definition TV Encoder I2C Slave Address */
#define     TV_I2C_ADDR_VT1622      0x40
#define     TV_I2C_ADDR_VT1622A     0x40
#define     TV_I2C_ADDR_VT1625      0x40

/* LVDS Transmitter I2C Slave Address */
#define     LVDS_I2C_ADDR_VT1636    0x80
#define     LVDS_I2C_ADDR_VT1631    0x70
#define     LVDS_I2C_ADDR_CHRONTEL  0xEA

/* RainLin [2006.03.07]: Hardware layout for internal LVDS/TMDS. */
#define     HW_LAYOUT_LCD_ONLY          0x01
#define     HW_LAYOUT_DVI_ONLY          0x02
#define     HW_LAYOUT_LCD_DVI           0x03
#define     HW_LAYOUT_LCD_LCD2          0x04
#define     HW_LAYOUT_LCD_EXTERNAL_LCD2 0x10
#define     HW_LAYOUT_TV_EXTERNAL_TV2   0x20

/*add by cliff for mergedfb*/
typedef enum {
   viaLeftOf,
   viaRightOf,
   viaAbove,
   viaBelow,
   viaClone
} VIAScrn2Rel;

/*add by cliff for mergedfb*/
typedef struct {
    int               bitsPerPixel;
    int               depth;
    int               displayWidth;
    int               pixel_code;
    int               pixel_bytes;
    DisplayModePtr    mode;
} VIAFBLayout;


typedef struct _VGABIOSVER
{
    CARD8   CoreBase;
    CARD8   ProductID;
    CARD8   MajorVer;
    CARD8   MinorVer;
} VGABIOSVER, *VGABIOSVERPtr;

typedef struct _GPIOI2C_INFO
{
    CARD8       bGPIOPort;
    CARD8       bSlaveAddr;
    int         I2C_WAIT_TIME;
    int         STARTTIMEOUT;
    int         BYTETIMEOUT;
    int         HOLDTIME;
    int         BITTIMEOUT;
} GPIOI2C_INFO, *PGPIOI2C_INFO;

typedef struct _VIABIOSSTDVGATABLE {
    CARD8           columns;
    CARD8           rows;
    CARD8           fontHeight;
    CARD16          pageSize;
    CARD8           SR[5];
    CARD8           misc;
    CARD8           CR[25];
    CARD8           AR[20];
    CARD8           GR[9];
} VIABIOSStdVGATableRec, *VIABIOSStdVGATablePtr;

typedef struct _VIAModeInfoPtr {
    int width;
    int height;
    int bpp;
    int modeno;
    CARD16  SupRefMask;     /* Support Refresh Rate Mask */
    struct _VIAModeInfoPtr *next;
} VIAModeInfoRec, *VIAModeInfoPtr;


typedef struct _VIABIOSREGTABLE {
    CARD8   port[VIA_BIOS_REG_TABLE_MAX_NUM];
    CARD8   offset[VIA_BIOS_REG_TABLE_MAX_NUM];
    CARD8   mask[VIA_BIOS_REG_TABLE_MAX_NUM];
    CARD8   data[VIA_BIOS_REG_TABLE_MAX_NUM];
    int     numEntry;
} VIABIOSRegTableRec, *VIABIOSRegTablePtr;


typedef struct _VIAVMODEENTRY {
    unsigned short          Width;
    unsigned short          Height;
    unsigned short          Bpp;
    unsigned short          Mode;
} VIAModeEntry, *VIAModeEntryPtr;

typedef struct _VIAREGTBL
{
    CARD8   port;
    CARD8   offset;
    CARD8   data;
} VIARegTblRec, *VIARegTblPtr;

typedef struct _VIALCDREGTBL
{
    CARD16  HDisplay;
    CARD16  VDisplay;
    CARD32  LCDClk;
    CARD32  VClk;
    VIARegTblRec  Reg[61];
} VIALCDRegTblRec, *VIALCDRegPtr;

typedef struct _VIALCDTBL
{
    CARD8               fpSize;
    VIALCDRegTblRec     VIALCDCtrTbl[9];
    VIALCDRegTblRec     VIALCDExpTbl[9];
} VIALCDTblRec, *VIALCDTblPtr;

typedef struct _VIALCDMODEENTRY {
    CARD16  LCDClk;
    CARD16  VClk;
    CARD16  LCDClk_12Bit;
    CARD16  VClk_12Bit;
    CARD8   port[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   offset[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   data[VIA_BIOS_REG_LCD_MAX_NUM];
    int     numEntry;
} VIALCDModeEntry, *VIALCDModeEntryPtr;


typedef struct _VIALCDMPATCHENTRY {
    CARD8   Mode;
    CARD16  LCDClk;
    CARD16  VClk;
    CARD16  LCDClk_12Bit;
    CARD16  VClk_12Bit;
    CARD8   port[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   offset[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   data[VIA_BIOS_REG_LCD_MAX_NUM];
    int     numEntry;
} VIALCDMPatchEntry, *VIALCDMPatchEntryPtr;


typedef struct _VIALCDMODEFIX {
    CARD8   reqMode[32];
    CARD8   fixMode[32];
    int     numEntry;
} VIALCDModeFixRec, *VIALCDModeFixRecPtr;


typedef struct _VIALCDPOWERSEQUENCE {
    CARD8   powerSeq;
    CARD8   port[4];
    CARD8   offset[4];
    CARD8   mask[4];
    CARD8   data[4];
    CARD16  delay[4];
    int     numEntry;
} VIALCDPowerSeqRec, *VIALCDPowerSeqRecPtr;


typedef struct _VIALCDMODETABLE {
    CARD8                   fpSize;
    CARD16                  SuptMode[VIA_BIOS_NUM_LCD_SUPPORT_MASK];    
} VIALCDModeTableRec, *VIALCDModePtr;

typedef struct _VIATVMASKTABLE {
    CARD8 TV[VIA_BIOS_MAX_NUM_TV_REG];
    CARD8 CRTC1[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 CRTC2[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 misc1;
    CARD8 misc2;
    int numTV;
    int numCRTC1;
    int numCRTC2;
} VIABIOSTVMASKTableRec, *VIABIOSTVMASKTablePtr;

typedef struct _VIATVMODETABLE {
    CARD8 TVNTSCC[VIA_BIOS_MAX_NUM_TV_REG];
    CARD8 TVNTSCS[VIA_BIOS_MAX_NUM_TV_REG];
    CARD8 CRTCNTSC1[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 MiscNTSC1[VIA_BIOS_NUM_TV_SPECIAL_REG];
    CARD8 MiscNTSC2[VIA_BIOS_NUM_TV_SPECIAL_REG];
    CARD8 CRTCNTSC2_8BPP[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 CRTCNTSC2_16BPP[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 CRTCNTSC2_32BPP[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD16 PatchNTSC2[VIA_BIOS_MAX_NUM_TV_PATCH];
    CARD16 DotCrawlNTSC[VIA_BIOS_NUM_TV_OTHER];
    CARD8 TVPALC[VIA_BIOS_MAX_NUM_TV_REG];
    CARD8 TVPALS[VIA_BIOS_MAX_NUM_TV_REG];
    CARD8 CRTCPAL1[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 MiscPAL1[VIA_BIOS_NUM_TV_SPECIAL_REG];
    CARD8 MiscPAL2[VIA_BIOS_NUM_TV_SPECIAL_REG];
    CARD8 CRTCPAL2_8BPP[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 CRTCPAL2_16BPP[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD8 CRTCPAL2_32BPP[VIA_BIOS_MAX_NUM_TV_CRTC];
    CARD16 PatchPAL2[VIA_BIOS_MAX_NUM_TV_PATCH];
} VIABIOSTV2TableRec, *VIABIOSTV2TablePtr;

typedef struct _VIAVMODETABLE {
    unsigned short          BIOSVer;
    char *                  BIOSDate;
    unsigned short          NumModes;
    int                     NumPowerOn;
    int                     NumPowerOff;
    VIAModeEntryPtr         Modes;
    VIABIOSRegTableRec      commExtTable;
    VIABIOSRegTableRec      stdModeExtTable;
    VIALCDPowerSeqRec       powerOn[VIA_BIOS_NUM_LCD_POWER_SEQ];
    VIALCDPowerSeqRec       powerOff[VIA_BIOS_NUM_LCD_POWER_SEQ];
    VIALCDModeFixRec        modeFix;
    VIABIOSTVMASKTableRec   tv2MaskTable;
    VIABIOSTV2TableRec      tv2Table[VIA_BIOS_NUM_TV2];
    VIABIOSTV2TableRec      tv2OverTable[VIA_BIOS_NUM_TV2];
} VIAModeTableRec, *VIAModeTablePtr;

typedef struct _3DSCAL_SCREENPARAS
{
    /* DISPLAY 3D SCALING PARAMETERS*/
    long            XSIZEMax;   	    /* The Max size(physical size,unit:pixel) */
    long            YSIZEMax;

    /*/adjust size*/    
    long            XSIZEMaxRange;   	/* this is the range  parametsers for SIZE (unit:pixel)*/
    long            YSIZEMaxRange;

    long            XScaleStep;        /*  step of X, Y scaling step value(unit:pixel)*/
    long            YScaleStep;    
    
    long            XScaleLevel;      /* X Current Scale level [0~MAX-1](unit:Level)*/
    long            XScaleDefault;    /* X Default Scale level*/
    long            XScaleMaximum;    /* X  max Scale level*/

    long            YScaleLevel;  
    long            YScaleDefault; 
    long            YScaleMaximum;

    long            XSIZEOffset;       /* the scaling offset of the size*/
    long            YSIZEOffset;
    
    long            XSIZENow;         /* the scaling result of the size*/
    long            YSIZENow;    

    /*adjust position*/
    long            XPOSITIONMaxRange;   	/* this is the range  parametsers for position (unit:pixel)*/
    long            YPOSITIONMaxRange;

    long            XPOSITIONStep;       	/*  Position adjust step value(unit:pixel)*/
    long            YPOSITIONStep;    
   
    long            XPOSITIONLevel;      /* X current position level [0~MAX-1](unit:level)*/
    long            XPOSITIONDefault;    /* X position level default value*/
    long            XPOSITIONMaximum;    /* X position max level*/

    long            YPOSITIONLevel;  
    long            YPOSITIONDefault; 
    long            YPOSITIONMaximum;

    long            XPOSITIONOffset;       /* the scaling offset of the POSITION*/
    long            YPOSITIONOffset;

    long            XPOSITIONNow;
    long            YPOSITIONNow;    

    /*flag to black the borders when adjust size and position*/
    Bool              bNeedBlack3dScalingBorders;    
    CARD32            AspectStatus;     /* Aspect ratio lock*/    
} VIA3DSclSCRNParas, *VIA3DSclSCNParasPtr;


typedef struct _TVINFO
{
    Bool    HasUserSetting;

    CARD32  DefaultScalH;
    CARD32  CurrentScalH;
    CARD32  ScalHLevel;

    CARD32  DefaultScalV;
    CARD32  CurrentScalV;
    CARD32  ScalVLevel;

    CARD32  DefaultPositionH;
    CARD32  CurrentPositionH;
    CARD32  PositionHLevel;

    CARD32  DefaultPositionV;
    CARD32  CurrentPositionV;
    CARD32  PositionVLevel;

    Bool    AdaptiveFFilterOn;

    CARD32  DefaultFFilter;
    CARD32  CurrentFFilter;
    CARD32  FFilterLevel;

    CARD32  DefaultAFFilter;
    CARD32  CurrentAFFilter;
    CARD32  AFFilterLevel;

    CARD32  DefaultBrightness;
    CARD32  CurrentBrightness;
    CARD32  BrightnessLevel;

    CARD32  DefaultContrast;
    CARD32  CurrentContrast;
    CARD32  ContrastLevel;

    CARD32  DefaultSaturation;
    CARD32  CurrentSaturation;
    CARD32  SaturationLevel;

    CARD32  DefaultTINT;
    CARD32  CurrentTINT;
    CARD32  TINTLevel;
    //the size and position info for scaling
    CARD32  XScalingLevel;
    CARD32  YScalingLevel;
    CARD32  XScalPosLevel;
    CARD32  YScalPosLevel;
} TVInfoRec, *TVInfoPtr;


typedef struct _CRTSETTINGINFO {
    int     ModeIndex;
    int     HActive;
    int     VActive;
    int     IGAPath;
    int     MonitorSizeH;
    int     MonitorSizeV;
    Bool    IsPanning;
} CRTSETTINGINFO, *CRTSETTINGINFOPTR;


typedef struct _TMDSSETTINGINFO {
    unsigned char   ChipID;
    int             I2CPort;
    unsigned char   I2CAddress;    
    unsigned char   BusWidth;   /* Digital Output Bus Width */
    int             DFPSize;        /* DVI panel size */
    Bool    IsDualEdge;
    int     ModeIndex;
    int     HActive;
    int     VActive;
    int     IGAPath;
    int     PanelSizeH;
    int     PanelSizeV;
    Bool    IsPanning;
} TMDSSETTINGINFO, *TMDSSETTINGINFOPTR;


typedef struct _LVDSSETTINGINFO {
    unsigned char   ChipID;
    int             I2CPort;
    unsigned char   I2CAddress;    
    unsigned char   BusWidth;   /* Digital Output Bus Width */
    Bool    IsDualEdge;     /* mean add-on card is 2CH or Dual or DDR */
    Bool    IsDithering;    /* Dithering Enable is for 18 bits panel and Disable is for 24 bits panel.*/
    int     DIPort;
    int     IGAPath;
    CARD32  VClk;           /* Clock of the mode table. */
    int     PanelSizeID;    /* LCD panel size ID */
    int     PanelSizeX;
    int     PanelSizeY;
    int     ModeIndex;
    int     HActive;
    int     VActive;
    Bool    Center;
    Bool    IsPanning;
} LVDSSETTINGINFO, *LVDSSETTINGINFOPTR;


typedef struct _TVSETTINGINFO {
    int     ModeIndex;
    int     HActive;
    int     VActive;
    int     IGAPath;
    Bool    IsPanning;
    int     TVEncoder;
    int     TVType;
    int     TVOutput;
    int     TVVScan;
    unsigned int    resTVMode;
    Bool    TVProgressive;  /* TV Progressive mode */
    Bool    TVDotCrawl;
    int     TVHScale;
    int     TVVScale;
    int     TVFlickerFilter;
    VIA3DSclSCRNParas TV3DScalInfo;
    TVInfoRec TVInfo;
    Bool    TVTypeIsNTSCJ;
    Bool    IsPreSetting;
} TVSETTINGINFO, *TVSETTINGINFOPTR;


typedef struct _IGASETTINGINFO {
    Bool    IsPanning;
    Bool    IsDISP3DScaling;
    int     HActive;
    int     VActive;
    int     CountWidthByQWord;
    int     OffsetWidthByQWord;
    Bool    SetStartingAddrFirstTime;   /* If not panning, we can use this flag to force to reset */
                                        /* starting address when set mode. */
    Bool    IsActive;                   /* Use to indicate if this IGA is in use. */
} IGASETTINGINFO, *IGASETTINGINFOPTR;


/***********************************************************************************/
/*                  Transmitter DPA Setting Structure                              */
/***********************************************************************************/
#include "via_tblDPASetting.h"

/* For adjusting DPA by option. (User Specified)*/
typedef struct VT1636_DPA_SETTING {
    int     PanelSizeID;
    CARD8   CLK_SEL_ST1;
    CARD8   CLK_SEL_ST2;
} VT1636DPASETTING, *VT1636DPASETTINGPTR;


typedef struct USER_DPA_SETTING_INFO {
    Bool                    HasUserSetting_Gfx;
    Bool                    HasUserSetting_VT1636;
    Bool                    HasUserSetting_VT1625;
    Bool                    HasUserSetting_VT1623;
    GFX_DPA_VALUE   GfxDPA;
    VT1636DPASETTING        VT1636DPA;
    CARD8                   VT1625DPA;
    CARD8                   VT1623DPA;
} USERDPASETTINGINFO, *USERDPASETTINGINFOPTR;

/***********************************************************************************/
/*                  VIA BIOS INFO Structure                                        */
/***********************************************************************************/
typedef struct _VIABIOSINFO {

    VIAModeTablePtr     pModeTable;

    int                 Chipset;
    int                 ChipRev;        
    
    int                 BIOSTVTabVer;

    unsigned char*      MapBase;
    Bool                FirstInit;
    unsigned char*      FBBase;
    unsigned char*      IntegratedTVMapBase;
    unsigned long       videoRambytes;
    unsigned char       MemClk;
    int                 scrnIndex;

    VIAModeInfoPtr      VIAModeList;
    int                 modeNum;        /* VESA Mode Number */
    unsigned int        mode, refresh, resMode;
    int                 resMode2;       /* FB device driver's res. index */
    int                 countWidthByQWord;
    int                 offsetWidthByQWord;
    Bool                EnableExtendedFIFO;

    CARD16              ConnectedDevice;
    CARD16              ActiveDevice;
    CARD16              DefaultActiveDevice;
    
    /* STChen[2006.8.24]:
       On the SAMM mode, pBIOSInfo->ActiveDevice only keep its own device state.
       So we can't know whose devices are actually active. So I add this variable to keep the actual active device state.
    */
    CARD32              ActualActiveDevice;

    Bool                FirstTimeToSenseIntegratedTV;   /* For integrated TV sense only. */
    int                 DisplayHardwareLayout;          /* Hardware layout for internal LVDS/TMDS. */

    /* Here are all the BIOS Relative Options */
    /* VansonWu [2004.4.21] Simplify Device ID + Revision ID combination */
    int                 dwProjectIDRevision;
    int                 BIOSMajorVersion;
    int                 BIOSMinorVersion;
    unsigned char       BIOSDateYear;
    unsigned char       BIOSDateMonth;
    unsigned char       BIOSDateDay;
    Bool                MobileFamily;
    Bool                Hotkey;         /* For Device Switch Hotkey, If it's TRUE,
                                         * driver will use int10 module to set mode */
    Bool                TwoLCD;         /*=* For Advantech Project, support two LCD MHS *=*/
    Bool                TwoCRT;         /*for Dual CRT with TV card vt1625*/   
    Bool                CRT2_SUPPORTED; /*support CRT2 Option with TV card vt1625 for S3Utility.*/   
    Bool                DuoView;        /*=* DuoView, only support for CN400 *=*/
    Bool                UseIGA2;
    Bool                CLE266A2;
    Bool                UseBIOS;

    Bool                DVIAttach;
    Bool                LCDAttach;
    Bool                TVAttach; 
    
    Bool                Panning;        /* Virtual Desktop or Not ? */
    
    Bool                EPIA_DVI;       /*for support DVI on EPIA*/   
    int                 IsDemoBoard;    /*for CN400 only ,DVI use DVP1/DVP1*/

    /* For TwinFS454 */
    Bool                HasTwoTVEncoder;/* Has Two TV Encoder or not ?*/    
    int                 TVOutput2;      /* 2nd TV Output signal type */
    unsigned char       TVI2CAdd_2;     /*=* For Hitachi DaVinCi Project *=*/
    
    int                 TVDIPort;       
    int                 DFPDIPort;
    int                 OptRefresh;
    int                 Refresh;
    int                 FoundRefresh;

    CRTSETTINGINFO      CRTSettingInfo;
    TVSETTINGINFO       TVSettingInfo;    
    TMDSSETTINGINFO     TMDSSettingInfo;
    LVDSSETTINGINFO     LVDSSettingInfo;    /* For LCD1. */
    
    /* For dual devices, like dual LCD, dual TV. Only for VT3324 now. */
    TVSETTINGINFO       TVSettingInfo2;
    LVDSSETTINGINFO     LVDSSettingInfo2;   /* For LCD2. */
 
    /* IGA setting */
    IGASETTINGINFO      IGA1SettingInfo;
    IGASETTINGINFO      IGA2SettingInfo;

    USERDPASETTINGINFO  UserDPASettingInfo;
    
    /* LCD Simultaneous Expand Mode HWCursor Y Scale */
    Bool                scaleY;
    int                 resY;

    /* Some Used Member of ScrnInfoRec */
    int                 bitsPerPixel;   /* fb bpp */
    int                 displayWidth;   /* memory pitch */
    int                 frameX1;        /* viewport position */
    int                 frameY1;
    int                 SaveframeX1;
    int                 SaveframeY1;
    int                 VirtualX;
    int                 VirtualY;
    int                 ActualDesktopSizeX;
    int                 ActualDesktopSizeY;

    /* Some Used Member of DisplayModeRec */
    int                 Clock;          /* pixel clock freq */
    int                 HTotal;
    int                 VTotal;
    int                 HDisplay;       /* horizontal timing */
    int                 VDisplay;       /* vertical timing */
    int                 SaveHDisplay;
    int                 SaveVDisplay;
    int                 CrtcHDisplay;
    int                 CrtcVDisplay;
    int                 SaveCrtcHDisplay;
    int                 SaveCrtcVDisplay;
    int                 SaveVirtualX;
    int                 SaveVirtualY;

    /* RainLin [2005.12.19]: For HW strapping issue. */
    int                 TVI2CPort;
    
    /* I2C & DDC */
    GPIOI2C_INFO        GPIOI2CInfo;
    I2CBusPtr           I2C_Port1;
    I2CBusPtr           I2C_Port2;
    xf86MonPtr          DDC1;
    xf86MonPtr          DDC2;
    I2CDevPtr           dev;

    unsigned char       TVI2CAdd;    
    unsigned char       TVRegs[0xFF];

    /* MHS */
    CARD16              PrimaryDevice;
    Bool                SAMM;           /* SAMM success or not? */
    Bool                IsSecondary;
    Bool                HasSecondary;
    Bool                SetTV;

    /* Utility User Setting */
    LOCO                colors[256];    /* Gamma value. LOCO typedef in colormapst.h */
    CARD8               SuspendTurnOFFDevice;   /*=* for [Hitachi Escher] suspend garbage *=*/
    Bool                s3utility;     /*The function call is from s3utility*/

    /* DuoView */
    int                 CRT2_IGA;    

    /*add by cliff for mergedfb*/
    VIAFBLayout         CurrentLayout;
    Bool                MergedFB;
    VIAScrn2Rel         Scrn2Position;
    /* char*            CRT2HSync;
    char*               CRT2VRefresh;
    char*               MetaModes;
    ScrnInfoPtr         CRT2pScrn;
    DisplayModePtr      CRT1Modes;
    DisplayModePtr      CRT1CurrentMode;
    int                 CRT1frameX0;
    int                 CRT1frameY0;
    int                 CRT1frameX1;
    int                 CRT1frameY1;*/
    int                 maxScrn1_X1, maxScrn1_X2, maxScrn1_Y1, maxScrn1_Y2;
    int                 maxScrn2_X1, maxScrn2_X2, maxScrn2_Y1, maxScrn2_Y2;
    Bool                UseVIAXinerama;
    /* Bool             CRT2IsScrn0;*/
    ExtensionEntry*     XineramaExtEntry;
    int                 VIAXineramaVX, VIAXineramaVY;
    /*Bool              AtLeastOneNonClone;
    int                 MergedFBXDPI, MergedFBYDPI;
    Bool                NoVirtual;*/
    
    /*add by cliff to set secondary screen's start address*/
    int                 HalfLine;
    unsigned long       HalfScreen;
    
    /*for ARGB cursor (use hardware icon ) add by cliff*/
    Bool  ARGB_cursor;
    int CursorStart;

    /* For option: driver version */
    int                 DriverVersionPatchLevel;

    /* For utility api. */
    ExtensionEntry*     DisplayExtEntry;

    /* STChen[2006.12.20]: For hardware rotation used. */
    int                 HWRotate;
    
    /*Display SW 3D scaling function surport caps*/
    Bool                DISP3DScaling;

    /*Display SW 3D scaling function enable flag*/
    Bool                Is3DScaling;
    Bool                Is3DScalingEnable;
    Bool                IsStableStatus;

    /* STChen[2007.3.8]: For MAMM, VIA is secondary display device. */
    Bool                IsMAMMEnable;

    /* STChen[2007.4.3]: Move NoDDCValue from VIAPtr struct to here. */
    Bool                NoDDCValue;
} VIABIOSInfoRec, *VIABIOSInfoPtr;

typedef struct _VIASUPPORTMODE {
    char  Name[10];
    int   ModeIndex;
    int   HActive;
    int   VActive;
} VIASUPPORTMODE;


/* Functions protype */

char* VIAGetBIOSInfo(VIABIOSInfoPtr pBIOSInfo);
unsigned char VIAGetActiveDisplay(VIABIOSInfoPtr pBIOSInfo);
/*Bool VIAPostDVI(VIABIOSInfoPtr pBIOSInfo);*/
unsigned char VIAGetDeviceDetect(VIABIOSInfoPtr pBIOSInfo);
Bool VIAGetBIOSTable(VIABIOSInfoPtr pBIOSInfo);
Bool VIAFindRefreshRate(VIABIOSInfoPtr pBIOSInfo, int ModeIndex);
Bool VIAFindModeUseModeList(VIABIOSInfoPtr pBIOSInfo);
Bool VIAFindModeUseBIOSTable(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetModeUseBIOSTable(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetModeForMHS(VIABIOSInfoPtr pBIOSInfo);
Bool VIASaveGamma(ScrnInfoPtr pScrn, LOCO *colors);
Bool VIARestoreGamma(ScrnInfoPtr pScrn, LOCO *colors);
void VIAPitchAlignmentPatch(VIABIOSInfoPtr pBIOSInfo);
void VIADelayIn_usec(VIABIOSInfoPtr pBIOSInfo, int usec);
Bool VIASetMode(VIABIOSInfoPtr pBIOSInfo);
void VIACRTDisable(void);
void VIACRTEnable(void);
void VIASetOutputPath(VIABIOSInfoPtr pBIOSInfo, int device, int set_iga, int output_interface);
void VIASetCRTOutputPath(int set_iga);
void VIACRTSetMode(VIABIOSInfoPtr pBIOSInfo, int vmode_index, int set_iga);

int BIOS_GetBIOSVersion(ScrnInfoPtr pScrn);
unsigned char BIOS_GetActiveDevice(ScrnInfoPtr pScrn);
Bool BIOS_GetBIOSDate(ScrnInfoPtr pScrn);
Bool BIOS_SetActiveDevice(ScrnInfoPtr pScrn);
int BIOS_QueryModeList(ScrnInfoPtr pScrn, int serno, int* ModeNo);
Bool BIOS_GetVESAModeInfo(ScrnInfoPtr pScrn, int ModeNo, int* Xres, int* Yres, int* bpp);
int BIOS_QuerySupportRefreshRate(ScrnInfoPtr pScrn, int ModeNo, int serno, int* refIndex);
Bool BIOS_SetFlatPanelState(ScrnInfoPtr pScrn, Bool expansion);
Bool VIACorrectMonitorSize(int* MonitorH, int* MonitorV); 
void VIAGetModeSizeByName(char *pName, int *pHSize, int *pVSize);
void VIAGetModeSizeByIndex(int ModeIndex, int *pHSize, int *pVSize);
void VIAGetPanelIndexByModeSize(CARD32 HRes, CARD32 VRes, CARD32* pPanelIndex);

void VIAGetPanelSizeByIndex(int PanelSizeIndex, int *pSizeX, int *pSizeY);
void VIASetDisplayChannel(VIABIOSInfoPtr pBIOSInfo);
Bool VIAEnumModes(VIABIOSInfoPtr pBIOSInfo, int IndexOfTable, VIASUPPORTMODE *pVIASupportMode, Bool *pIsSupported);
void VIAEnumRefreshRate(int ModeIndex, int RefreshRateNum, int *pRefreshRate);

int VIAGetModeIndex(int HorResolution, int VerResolution);

/* in via_bandwidth.c */
void VIADisabledExtendedFIFO(VIABIOSInfoPtr pBIOSInfo);
void VIAEnabledPrimaryExtendedFIFO(VIABIOSInfoPtr pBIOSInfo);
void VIAEnabledSecondaryExtendedFIFO(VIABIOSInfoPtr pBIOSInfo);
void VIAFillExpireNumber(VIABIOSInfoPtr pBIOSInfo);
void VIASetDPA_Gfx(int DIPort, GFX_DPA_VALUE_PTR pGfxDPASetting);
void ViaModesAttachHelper(ScrnInfoPtr pScrn, MonPtr monitorp, DisplayModePtr Modes);

/* in hw.c */
CARD32 get_clk_value(VIABIOSInfoPtr pBIOSInfo, int clk);
void set_color_depth(VIABIOSInfoPtr pBIOSInfo, int bpp_byte, int set_iga);
void InitTVChipInfo(VIABIOSInfoPtr pBIOSInfo);
void load_crtc_timing(VIABIOSInfoPtr pBIOSInfo, struct display_timing device_timing, int set_iga);


extern VIABIOSTVMASKTableRec tv2MaskTable;
extern VIABIOSTV2TableRec tv2Table[];
extern VIABIOSTV2TableRec tv2OverTable[];

#endif  /* _VIA_BIOS_H_ */

