
#include "via_driver.h"
#include "via_tblDPASetting.h"

/*******************************************************************************/
/*                      LVDS VT1636 Default DPA Setting                        */
/*******************************************************************************/

/* Note_1:  0xFFFFFF indicate the end of array.*/
/* Note_2:  0xData + Mask + Address            */
/* Example: 0x00   + 0F   + 08 = 0x000F08      */                                      
CARD32 VT1636_CLK_SEL_ST_DEFAULT[] = {0x000F08, 0x001F09, 0xFFFFFF}; 


/*******************************************************************************/
/*              Include file of DPA table by chip                              */
/*******************************************************************************/

#include "via_tblDPA_vt3259.h"
#include "via_tblDPA_vt3314.h"
#include "via_tblDPA_vt3324.h"
#include "via_tblDPA_vt3336.h"
#include "via_tblDPA_vt3327.h"
#include "via_tblDPA_vt3364.h"

/*******************************************************************************/
/*                          GFX DPA Index Table                                */
/*******************************************************************************/
GFX_DPA_INDEX_TABLE GFX_DPA_INDEX_TBL[] = {
    {VIA_PM800,     GFX_DPA_TABLE_VT3259_VT1625, NULL,   NULL,                    NULL},
    {VIA_P4M800PRO, GFX_DPA_TABLE_VT3314_VT1625, NULL,   NULL,                    NULL},
    {VIA_CX700,     GFX_DPA_TABLE_VT3324_VT1625, NULL,   GFX_DPA_VT3324_VT1636,   NULL},
    {VIA_K8M890,    GFX_DPA_TABLE_VT3336_VT1625, NULL,   GFX_DPA_VT3336_VT1636,   GFX_DPA_VT3336_HardwiredLCD},
    {VIA_P4M890,    GFX_DPA_TABLE_VT3327_VT1625, NULL,   GFX_DPA_VT3327_VT1636,   GFX_DPA_VT3327_HardwiredLCD},
    {VIA_CN750,     NULL,                        NULL,   NULL,                    NULL},
    {VIA_P4M900,    GFX_DPA_TABLE_VT3364_VT1625, NULL,   GFX_DPA_VT3364_VT1636,   GFX_DPA_VT3364_HardwiredLCD},
    {0xFFFFFFFF,    NULL,   NULL}
};

/*******************************************************************************/
/*                          Transmitter DPA Index Table                        */
/*******************************************************************************/
TRANSMITTER_DPA_INDEX_TABLE TRANSMITTER_DPA_INDEX_TBL[] = {
    {VIA_PM800,     NULL,   NULL},
    {VIA_P4M800PRO, NULL,   NULL},
    {VIA_CX700,     NULL,   TRANSMITTER_DPA_VT3324_1636TBL},
    {VIA_K8M890,    NULL,   NULL},
    {VIA_P4M890,    NULL,   TRANSMITTER_DPA_VT3327_1636TBL},
    {VIA_CN750,     NULL,   NULL},
    {VIA_P4M900,    NULL,   NULL},
    {0xFFFFFFFF,    NULL,   NULL}
};

