#ifndef __XF86DRI_VIA_H__
#define __XF86DRI_VIA_H__ 1

#include "close/via_drm.h"

typedef struct {
    unsigned long sarea_priv_offset;
    unsigned long fb_offset;
    unsigned long mmio_offset;
    unsigned long agpAddr;
 /*homer agp flush drm*/
 		unsigned long agp_offset;
 /*homer end*/
} drmVIAInit;

typedef struct {
    unsigned int offset;
    unsigned int size;
/*=* John Sheng [2004.6.3] For AMD64 *=*/
#ifndef __x86_64__
    unsigned int index;
#else
    unsigned long index;
#endif
} drmVIAAGPBuf;

typedef struct {
    unsigned int offset;
    unsigned int size;
    unsigned long index;
    unsigned long *address;
} drmVIADMABuf;

extern int drmVIAAgpInit(int fd, int offset, int size);
extern int drmVIAFBInit(int fd, int offset, int size);
extern int drmVIAInitMAP(int fd, drmVIAInit *info);
extern int drmVIAAllocateDMA(int fd, drmVIADMABuf *buf);
extern int drmVIAReleaseDMA(int fd, drmVIADMABuf *buf);

/*Homer for support h5s1(vt3336/vt3364)*/
typedef struct {
    enum {
        S3G_INIT    = 0x01,
        S3G_CLEANUP = 0x02
    } func;

    int chip_agp;    
    int chip_index;
    int chip_sub_index;

    int usec_timeout;
    
    unsigned int   sarea_priv_offset;
    
    unsigned int   fb_cpp;
    unsigned int   front_offset;
    unsigned int   back_offset;
    unsigned int   depth_offset;

    unsigned int   mmio_handle;
    unsigned int   dma_handle;
    unsigned int   fb_handle;
    unsigned int   front_handle;
    unsigned int   back_handle;
    unsigned int   depth_handle;

    unsigned int   fb_tex_offset;
    unsigned int   fb_tex_size;

    unsigned int   agp_tex_size;    
    unsigned int   agp_tex_handle;

    unsigned int   shadow_size;
    unsigned int   shadow_handle;

    unsigned int   garttable_size;
    unsigned int   garttable_offset;

    unsigned long  available_fb_size;
    unsigned long  fb_base_address;

    unsigned int   DMA_size;
    unsigned long  DMA_phys_address;

    /*homer for set AGP buffer type*/
    enum 
    {
        AGP_RING_BUFFER,
        AGP_DOUBLE_BUFFER,
        AGP_DISABLED
    }agp_type;
    /*end*/
} drm_s3g_init_t;
/*Homer end*/
 
#endif  /* __XF86DRI_VIA_H__ */
